import pickle
import sys

# načtení získaného slovníku trojic
# ~ je to binární soubor => nedochází k žádné interpretaci pomocí kódování
with open('informace.pickle', mode='br') as soubor:
    hustoty = pickle.load(soubor)

# žádné vstupní parametry
if len(sys.argv) == 1:
    sys.exit('Nezadali jste žádný požadavek => končím...')
else:
    číslo = int(sys.argv[1])

print(f'Pracuji s parametrem: {číslo}')
# vypiš číslo-tý stát s nejvyšší hustotou
for pořadí, (země, informace) in enumerate(
    # přes co cyklím
    sorted(
        # co řadíme (jsou to dvojce!)
        hustoty.items(),
        # podle čeho řadíme (hustota z druhého prvku dvojice)
        key=lambda info: info[-1][-1],
        # výsledek vypíšeme v opačném pořadí
        reverse=True
    ),
    # od jakého čísla enumerate() začíná počítat
    start=1
):
    if pořadí == číslo:
        # rozbalení údajů o zemi do samostatných proměnných
        plocha, obyvatel, hustota = informace
        # výpis údajů o zemích
        # ~ jako bych napsal {země:<44}
        print(f'{pořadí:>3} {země} --> {obyvatel} obyvatel na {plocha} km^2 => hustota {hustota:.0f}')
        # a tím končíme, netřeba pokračovat v prohledávání dál
        break

'''
> python 05_cvičení.py 3
Pracuji s parametrem: 3
  3 Hong Kong --> 6860000 obyvatel na 1092 km^2 => hustota 6282
'''
