import pickle
import sys

# načtení získaného slovníku trojic
# ~ je to binární soubor => nedochází k žádné interpretaci pomocí kódování
with open('informace.pickle', mode='br') as soubor:
    hustoty = pickle.load(soubor)

# žádné vstupní parametry
if len(sys.argv) == 1:
    sys.exit('Nezadali jste žádný požadavek => končím...')
else:
    n = int(sys.argv[1])
    m = int(sys.argv[2])

print(f'Pracuji s parametry: {n} & {m}')
# vypiš státy podle hustoty, ale jen ty od n-tého po m-tý
for pořadí, (země, informace) in enumerate(
    # přes co cyklím
    sorted(
        # co řadíme (jsou to dvojce!)
        hustoty.items(),
        # podle čeho řadíme (hustota z druhého prvku dvojice)
        key=lambda info: info[-1][-1],
        # výsledek vypíšeme v opačném pořadí
        reverse=True
    ),
    # od jakého čísla enumerate() začíná počítat
    start=1
):
    if pořadí >= n and pořadí <= m:
        # rozbalení údajů o zemi do samostatných proměnných
        plocha, obyvatel, hustota = informace
        # výpis údajů o zemích
        # ~ jako bych napsal {země:<44}
        print(f'{pořadí:>3} {země} --> {obyvatel} obyvatel na {plocha} km^2 => hustota {hustota:.0f}')
    # a tím končíme, netřeba pokračovat v prohledávání dál
    if pořadí > m:
        break

'''
> python 07_cvičení.py 3 7
Pracuji s parametry: 3 & 7
  3 Hong Kong --> 6860000 obyvatel na 1092 km^2 => hustota 6282
  4 Singapore --> 4350000 obyvatel na 692.7 km^2 => hustota 6280
  5 Gibraltar --> 27800 obyvatel na 6.5 km^2 => hustota 4277
  6 Gaza Strip --> 1320000 obyvatel na 360 km^2 => hustota 3667
  7 Holy See (Vatican City) --> 921 obyvatel na 0.44 km^2 => hustota 2093
'''
